# SourcePath:	shadow/20170221dev
Summary   	: Utilities for managing shadow password files and user/group accounts.
Name	  	: sony-target-dev-shadow
%define	pkgname	%{sony_tool_triplet}-%{sony_target_dialect}-dev-shadow
Version	  	: 4.2.1
Release: 12000002
URL		: http://www.nanotech.wisc.edu/shadow/source
Source	  	: ftp://ftp.ists.pwr.wroc.pl/pub/linux/shadow/shadow-%{version}.tar.xz
Source1		: shadow-LICENSE
Source2		: login_defs_pam.sed
Patch1		: shadow-ss-4.2.1.diff
Patch2		: shadow-4.2.1-stdarg.patch
Patch3		: shadow-4.2.1-dots-in-usernames.patch
Patch4		: shadow-4.2.1-remove-pam-selinux-so.patch
Patch5		: shadow-4.2.1-cross.patch
License 	: BSD / GPLv2
Distribution:	%{sony_distribution}
Vendor:		%{sony_vendor}
Packager:	%{sony_packager}
Group:		%{sony_group}
Buildroot 	: %{_tmppath}/%{name}-root
Prefix	  	: %{sony_target_dir}
%define _defaultdocdir	%{sony_target_dir}%{sony_target_dev_doc_dir}
Provides: /usr/sbin/groupadd
#
#	SRPM
#

%description

This is the source RPM for the shadow-utils binary packages in Hard Hat
Linux.

%package -n %{pkgname}
Summary   	: Utilities for managing shadow password files and user/group accounts.
Group:	%{sony_group}
AutoReqProv: no

%description -n %{pkgname}

This is the source RPM for the shadow-utils binary packages in Hard Hat
Linux.

#
#	RPM
#


%prep

%setup -n shadow-%{version}

cp %{SOURCE1} LICENSE

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
%sony_target_dev_setup
%target_acplatvars

# commented  to fix build error due to libtools version update
#dialect=%{sony_target_dialect} %{sony_target_toolprefix}libtoolize --copy --force
export ac_cv_func_setpgrp=${ac_cv_func_setpgrp=yes}
export ac_cv_arg_setpgrp_negpid=${ac_cv_arg_setpgrp_negpid=yes}
export ac_cv_func_setpgrp_nargs=${ac_cv_func_setpgrp_nargs=0}
export ac_cv_func_setpgrp_void=${ac_cv_func_setpgrp_void=yes}

# Comment from debian is that shared lib support is untested..
# (It doesn't appear to work)
%sony_target_dev_configure --with-libpam --disable-shared --disable-account-tools-setuid

make LDFLAGS="" CFLAGS=""


%install
%sony_target_dev_setup
rm -rf %{buildroot}

mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/bin
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}
### mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/cron.daily
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/pam.d
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man1
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man3
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man5
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man8
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_local_bin_dir}
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}

%sony_target_dev_makeinstall LDFLAGS="" CFLAGS=""


# From binary-login:
###      install -d %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/{bin,etc/init.d,usr/{bin,sbin}}
        install -d %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/{bin,etc/usr/{bin,sbin}}
        install  -m0755 src/login %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/bin/
        install  -m4755 src/newgrp %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/usr/bin/
        install  src/{faillog,lastlog} %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/usr/bin/
        install  src/logoutd %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/usr/sbin/
	install ../etc/{login.access,limits,login.defs} %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}
        install -m644 ../man/man1/{login.1,newgrp.1} %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man1/
        install -m644 ../man/man5/{login.defs.5,login.access.5,porttime.5,faillog.5,limits.5} %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man5/
        install -m644 ../man/man8/{faillog.8,logoutd.8,lastlog.8} %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man8/
	ln -s newgrp.1.gz %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man1/sg.1.gz
###	install ../debian/logoutd.init %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/etc/init.d/logoutd

# From binary-passwd:
###	install -d %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}%{sony_target_dev_dir}{etc/{cron.daily,init.d},usr/{sbin,bin}}
	install -d %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}%{sony_target_dev_dir}{etc/usr/{sbin,bin}}
###	install ../debian/passwd.cron %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/etc/cron.daily/passwd
###        install ../debian/passwd.init %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/etc/init.d/passwd
        install  -m4755 src/{chage,chfn,chsh,expiry,gpasswd,passwd} %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/usr/bin/
        install  src/{chpasswd,groupadd,groupdel,groupmod,grpck,grpconv,grpunconv} \
          src/{newusers,pwck,pwconv,pwunconv,useradd,userdel} \
          src/{usermod,vipw} %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/usr/sbin/
        install -m644 ../man/man1/{chage.1,chfn.1,chsh.1,gpasswd.1,passwd.1} \
          %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man1/
        install -m644 ../man/man8/{chpasswd.8,groupadd.8,groupdel.8,groupmod.8,grpck.8} \
          ../man/man8/{newusers.8,pwck.8} \
          ../man/man8/{useradd.8,userdel.8,usermod.8,vipw.8,pwconv.8} \
          %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man8/
        install -m644 ../man/man5/{passwd.5,shadow.5} %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man5/
	ln -s vipw.8.gz %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man8/vigr.8.gz
	for i in pwunconv.8.gz grpconv.8.gz grpunconv.8.gz ; do \
	  ln -s pwconv.8.gz %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man8/$i ; done

# from binary-su:
        install -d %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/{etc,bin,usr/}
        install -m4755 src/su %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/bin/
        install -m644 ../man/man5/suauth.5 %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man5/
        install -m644 ../man/man1/su.1 %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man1/
	install -m644 ../etc/pam.d/{chfn,chage,chgpasswd,chpasswd,chsh,groupadd,groupdel,groupmems,groupmod,login,newusers,passwd,su,useradd,userdel,usermod} %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/pam.d/

        install lib/.libs/libshadow.a %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}
        install lib/.libs/../libshadow.la %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}

	sed -i -f %{SOURCE2} %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/login.defs
	touch %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/pam.d/system-auth

# gzip man pages
### find %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir} -type f | xargs gzip -9

mv %{buildroot}%{sony_target_dir}/usr/%{sony_target_dev_sysconf_dir}  %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}

# cleanup
#	rm -f %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}/cppw
#	ln -s cppw %{buildroot}%{sony_target_dir}%{sony_target_dev_sbin_dir}/cpgr

	rm -f %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}/su
	rm -rf %{buildroot}%{sony_target_dir}/usr/%{sony_target_dev_sysconf_dir}
	rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}%{sony_target_dev_sysconf_dir}


%demangle_libtool

rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}

mv %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/bin/login       %{buildroot}%{sony_target_dir}%{sony_target_dev_local_bin_dir}/login
mv %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/usr/bin/chsh    %{buildroot}%{sony_target_dir}%{sony_target_dev_local_bin_dir}/chsh
mv %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/usr/bin/chfn    %{buildroot}%{sony_target_dir}%{sony_target_dev_local_bin_dir}/chfn

# 6.x
for b in `ls %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}`; do
    case $b in
        *-config)
          mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}
          mv %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}/$b \
             %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}
          ;;
    esac
done


for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}`; do
    case $l in
        *.a|pkgconfig)
          mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
          mv %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l \
             %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
          ;;
    esac
done

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}`; do
    if [ "$l" != "pkgconfig" ]; then
        ln -s ../..%{sony_target_devtool_lib_dir}/$l \
            %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l
    fi
done

rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_sharedstate_dir}/man

%clean
rm -rf %{buildroot}


%files -n %{pkgname}
%defattr(-,root,root)
%{sony_target_dir}%{sony_target_dev_bin_dir}/*
%{sony_target_dir}%{sony_target_dev_local_bin_dir}/*
%{sony_target_dir}%{sony_target_dev_dir}/bin/su
%{sony_target_dir}%{sony_target_dev_dir}/bin/groups
%{sony_target_dir}%{sony_target_dev_dir}/sbin/nologin
%{sony_target_dir}%{sony_target_dev_local_bin_dir}/login
%config %{sony_target_dir}%{sony_target_dev_sysconf_dir}/limits
%config %{sony_target_dir}%{sony_target_dev_sysconf_dir}/login.access
%config %{sony_target_dir}%{sony_target_dev_sysconf_dir}/login.defs
%config %{sony_target_dir}%{sony_target_dev_sysconf_dir}/pam.d/*
%{sony_target_dir}%{sony_target_dev_sbin_dir}/*
%{sony_target_dir}%{sony_target_dev_lib_dir}/*
%{sony_target_dir}%{sony_target_devtool_lib_dir}/*.a


%changelog
* Mon Dec 25 2019 Sony Corporation 
- Updated License to BSD / GPLv2.
 
* Tue Jul 28 2015 Sony Corporation
- Fixed broken link issue by removing cpgr.

* Mon Aug 12 2013 Sony Corporation
- Changed License information.

* Mon May 06 2013 Sony Corporation
- Fix for adding/creating users/groups
- Disable setuid

* Mon Apr 01 2013 Sony Corporation
- Version updated to 4.1.5

* Fri Oct 29 2010 Sony Corporation
- removed libtoolize --copy --force

* Fri May 02 2008 Sony Corporation
- version downgrading 4.0.18.1 -> 20000902

* Mon Apr 28 2008 Sony Corporation
- version-up 20000902 -> 4.0.18.1

* Thu Jun 15 2006 Sony Corporation
- change Install Location: su, login

* Tue May 10 2005 Sony Corporation
- modify symbolic links

* Fri Apr 8 2005 Sony Corporation
- change default PATH

* Fri Mar 25 2005 Sony Corporation
- add some links

* Tue Dec 21 2004 Sony Corporation
- remove LICENSE

* Thu Nov 18 2004 Sony Corporation
- delete online manual

* Tue Nov  9 2004 Sony Corporation
- Initial version
